import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class MyWorld extends World
{
    private Scroller scroll; //Implements the Scroller() class in the MyWorld() class
    score score = new score(); //Implements the score() class in the MyWorld() class
    lives lives = new lives(); //Implements the lives() class in the MyWorld() class
    
    public MyWorld()
    {    
        //This method is where all the methods from this class is called
        super(1300, 860, 1,false); //Sets the size of the world
        Greenfoot.setSpeed(50); //Sets the Greenfoot speed bar to 50
        levelOne(); //Calls the levelOne() method
        getScore(); //Calls the getScore() method
        getLives(); //Calls the getLives() method
    }
    
    public void levelOne()
    {
        //This method places all the graphics and classes of the game into the world
        sprite sprite = new sprite(); //Calls the sprite() class
        addObject(sprite,41,753); //Adds and sets the position of the sprite in the world
        block2 block2 = new block2(); //Calls the block2() class
        spike spike = new spike(); //Calls the spike() class
        boxPlatform boxPlatform = new boxPlatform(); //Calls the boxPlatform() class
        
        //These for loops are to add objects within a certain range in the game
        for (int x = 15; x < 1500; x += 47)
        {
            for (int y = 830; y <= 860; y += 47)
            {
                addObject( new block2(), x, y);
            }
        }
        for (int x = 1510; x < 1690; x += 47)
        {
            for (int y = 840; y <= 870; y += 47)
            {
                addObject( new spike(), x, y);
            }
        }
        for (int x = 1700; x < 2500; x += 47)
        {
            for (int y = 830; y <= 860; y += 47)
            {
                addObject( new block2(), x, y);
            }
        }
        for (int x = 2510; x < 2750; x += 47)
        {
            for (int y = 840; y <= 870; y += 47)
            {
                addObject( new spike(), x, y);
            }
        }
        for (int x = 2730; x < 3600; x += 47)
        {
            for (int y = 830; y <= 860; y += 47)
            {
                addObject( new block2(), x, y);
            }
        }
        for (int x = 3610; x < 3790; x += 47)
        {
            for (int y = 840; y <= 870; y += 47)
            {
                addObject( new spike(), x, y);
            }
        }
        for (int x = 3800; x < 4600; x += 47)
        {
            for (int y = 830; y <= 860; y += 47)
            {
                addObject( new block2(), x, y);
            }
        }
        for (int x = 1500; x < 1700; x += 47)
        {
            for (int y = 650; y <= 650; y += 47)
            {
                addObject( new boxPlatform(), x, y);
            }
        }
        for (int x = 2510; x < 2700; x += 47)
        {
            for (int y = 650; y <= 650; y += 47)
            {
                addObject( new boxPlatform(), x, y);
            }
        }
        for (int x = 3400; x < 3625; x += 47)
        {
            for (int y = 650; y <= 650; y += 47)
            {
                addObject( new boxPlatform(), x, y);
            }
        } 
        for (int x = 3775; x < 4000; x += 47)
        {
            for (int y = 650; y <= 650; y += 47)
            {
                addObject( new boxPlatform(), x, y);
            }
        }
        
        //This block of addObject code is adding different objects into the game and setting them in a coordinate in the world
        addObject(new CactusEnemy(), 1600, 590);
        addObject(new CactusEnemy(), 2600, 590);        
        addObject(new CactusEnemy(), 3500, 590);
        addObject(new CactusEnemy(), 3875, 590);
        addObject(new CactusEnemy(), 4200, 760);
        addObject(new Enemy(), 2025, 773);
        addObject(new Enemy(), 3300, 773);
        addObject(new Enemy(), 3875, 773);
        addObject(new boxPlatform(), 1600, 450);
        addObject(new coins(), 1600, 385); 
        addObject(new coins(), 2540, 735);
        addObject(new coins(), 3000, 555);
        addObject(new coins(), 3590, 750);
        addObject(new coins(), 4125, 420);
        addObject(new portal(), 4540, 740);
        addObject(score, 75, 50);
        addObject(lives, 1225, 50);
    }
    
    public void worldBGScene()
    {
        //This method sets the background of the world to my chosen background image
        GreenfootImage bg = new GreenfootImage ("BG.png");
    }
    
    public void scrollSpeed(int amount)
    {
        //This method calls a the checkKeyPress() method in the Scroller() class 
        scroll.checkKeyPress(amount);
    }
    
    public score getScore()
    {
        return score; //Calls the score() class
    }
    
    public lives getLives()
    {
        return lives; //Calls the lives() class
    }
    
    public void gameOver()
    {
        //This method removes all objects in the game and displays the game over screen
        removeObjects(getObjects(Actor.class));
        setBackground("BlackScreen.jpg");
        addObject(new GameOver(), 650, 430);
    }
    
    public void levelCompleted()
    {
        //This method removes all the objects in the game and displays the level completed screen
        removeObjects(getObjects(Actor.class));
        setBackground("BG.png");
        addObject(new LevelComplete(), 650, 430);
    }
}